## 4 `sa` ¶

`sa` summarizes information about previously executed commands as recorded in the `acct` file. In addition, it condenses this data into the `savacct` summary file, which contains the number of times the command was called and the system resources used. The information can also be summarized on a per-user basis; `sa` will save this information into `usracct`. Usage:

`sa [opts] [file]`

If no arguments are specified, `sa` will print information about all of the commands in the `acct` file. If command names have unprintable characters, or are only called once, `sa` will sort them into a group called `***other`. Overall totals for each field are gathered and printed with a blank command name.

If called with a file name as the last argument, `sa` will use that file instead of `acct`.

By default, `sa` will sort the output by sum of user and system time.

The output fields are labeled as follows:

`cpu`

  sum of system and user time in cpu seconds

`re`

  “real time” in cpu seconds

`k`

  cpu-time averaged core usage, in 1k units

`avio`

  average number of I/O operations per execution

`tio`

  total number of I/O operations

`k*sec`

  cpu storage integral (kilo-core seconds)

`u`

  user cpu time in cpu seconds

`s`

  system time in cpu seconds

Note that these column titles do not appear in the first row of the table, but after each numeric entry (as units of measurement) in every row. For example, you might see `79.29re`, meaning 79.29 cpu seconds of “real time.”

An asterisk will appear after the name of commands that forked but didn’t call `exec`.

### 4.1 Flags ¶

The availability of these program options depends on your operating system. In specific, the members that appear in the `struct acct` of your system’s process accounting header file (usually `acct.h`) determine which flags will be present. For example, if your system’s `struct acct` doesn’t have the `ac_mem` field, the installed version of `sa` will not support the `--sort-cpu-avmem`, `--sort-ksec`, `-k`, or `-K` options.

In short, all of these flags may not be available on your machine.

`-a`
`--list-all-names`

  Force `sa` not to sort those command names with unprintable characters and those used only once into the ‘`***other`’ group.

`-b`
`--sort-sys-user-div-calls`

  Sort the output by the sum of user and system time divided by the number of calls.

`-c`
`--percentages`

  Print percentages of total time for the command’s user, system, and real time values.

`-d`
`--sort-avio`

  Sort the output by the average number of disk I/O operations.

`-D`
`--sort-tio`

  Print and sort the output by the total number of disk I/O operations.

`-f`
`--not-interactive`

  When using the `--threshold` option, assume that all answers to interactive queries will be affirmative.

`-i`
`--dont-read-summary-file`

  Don’t read the information in `savacct`.

`-j`
`--print-seconds`

  Instead of printing total minutes for each category, print seconds per call.

`-k`
`--sort-cpu-avmem`

  Sort the output by cpu time average memory usage.

`-K`
`--sort-ksec`

  Print and sort the output by the cpu-storage integral.

`-l`
`--separate-times`

  Print separate columns for system and user time; usually the two are added together and listed as `cpu`.

`-m`
`--user-summary`

  Print the number of processes and number of CPU minutes on a per-user basis.

`-n`
`--sort-num-calls`

  Sort the output by the number of calls. This is the default sorting method.

`-p`
`--show-paging`

  Print the number of minor and major pagefaults and swaps.

`-P`
`--show-paging-avg`

  Print the number of minor and major pagefaults and swaps divided by the number of calls.

`-r`
`--reverse-sort`

  Sort output items in reverse order.

`-s`
`--merge`

  Merge the summarized accounting data into the summary files `savacct` and `usracct`.

`-t`
`--print-ratio`

  For each entry, print the ratio of real time to the sum of system and user times. If the sum of system and user times is too small to report—the sum is zero—`*ignore*` will appear in this field.

`-u`
`--print-users`

  For each command in the accounting file, print the userid and command name. After printing all entries, quit. Note: this flag supersedes all others.

`-v num`
`--threshold num`

  Print commands which were executed num times or fewer and await a reply from the terminal. If the response begins with `y`, add the command to the `**junk**` group.

`--separate-forks`

  It really doesn’t make any sense to me that the stock version of `sa` separates statistics for a particular executable depending on whether or not that command forked. Therefore, GNU `sa` lumps this information together unless this option is specified.

`--sort-real-time`

  Sort the output by the “real time” (elapsed time) for each command.

`--ahz hz`

  Use this flag to tell the program what `AHZ` should be (in hertz). This option is useful if you are trying to view an `acct` file created on another machine which has the same byte order and file format as your current machine, but has a different value for `AHZ`.

`--debug`

  Print verbose internal information.

`-V`
`--version`

  Print `sa`’s version number.

`-h`
`--help`

  Print `sa`’s usage string and default locations of system files to standard output.

Note: if more than one sorting option is specified, the list will be sorted by the one specified last on the command line.

### 4.2 Problems ¶

I haven’t been able to test this on many different machines because the data files grow so big in a short time; our sysadmin would rather save the disk space.

Most versions of `sa` that I’ve tested don’t pay attention to flags like `--print-seconds` and `--sort-num-calls` when printing out commands when combined with the `--user-summary` or `--print-users` flags. GNU `sa` pays attention to these flags if they are applicable.

#### 4.2.1 mips sa ¶

The average memory use is stored as a short rather than a double, so we suffer from round-off errors. GNU `sa` uses double the whole way through.